from DateTime import DateTime

project = context
portal = context.getPortalObject()
trash_tool = portal.portal_trash
preference_tool = portal.portal_preferences

destination_value = portal.portal_membership.getAuthenticatedMember().getUserValue()

allocation_predicate_list = project.Project_getSoftwareProductPredicateList(destination_value=destination_value)

now = DateTime()
# XXX HARDCODED. Probably not the correct configuration. It may be instead linked to the project / web site?
currency = preference_tool.getPreferredAccountingTransactionCurrency()

result_list = []

for allocation_predicate in allocation_predicate_list:

  software_product = allocation_predicate.getResourceValue()
  software_type = allocation_predicate.getSoftwareType()
  software_release = allocation_predicate.getSoftwareRelease()

  tmp_context = trash_tool.newContent(
    portal_type='Sale Order Line',
    temp_object=1,
    resource_value=software_product,
    variation_category_list=[software_release, software_type],
    start_date=now,
    destination_project_value=project,
    destination_value=destination_value,
    quantity_unit=software_product.getQuantityUnit(),
    price_currency=currency
  )
  tmp_context = tmp_context.newContent(
    portal_type='Sale Order Cell',
    temp_object=1,
    software_type_value=software_type,
    software_release_value=software_release
  )

  price = tmp_context.getPrice(None)
  if price is not None:
    result_list.append(allocation_predicate.asContext(
      title = '%s (%s %s/%s)' % (software_product.getTitle(), price, tmp_context.getPriceCurrencyTitle(), tmp_context.getQuantityUnitTitle())
    ))

return result_list
